/*
 macos/blitter.c
  used primarily for 2x2 copy

  Created: 2008.08.04
  Revised: 2015.10.05

2011.03.05
*/

#include <QuickDraw.h>

#include "shell.h"
#include "macvideo.h"

#include "../common/dface.h"

/* ---- globals */

extern uint32	myctable15[256];
extern uint32	myctable32[256];

/* ---- code */

 /* 2x1x8bpp */
 #define _bcpy2(d,s,c) do{ \
	void *__d=d; const void *__s=s; /*uint32 *__dd=(uint32*)((r)+(uint8*)__d);*/ \
	int32 __z=c,__t; \
	if(__z&2) __t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
	if(__z&4) __t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101, \
		__t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
	while(!((__z+=-8)<0)) { \
		__t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
		__t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
		__t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
		__t=*((uint8*)__s)++*0x101<<16,*((uint32*)__d)++= \
		__t|=*((uint8*)__s)++*0x101; \
	} \
	if(__z&1) *(uint16*)__d=*((uint8*)__s)*0x101;}while(0)
/* 1x1x15bpp */
#define _hcpy(d,s,c,t) do{ \
	void *__d=d; const void *__s=s; int32 __z=c,__t; \
	if(__z&2) __t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++); \
	if(__z&4) __t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++), \
		__t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++); \
	while(!((__z+=-8)<0)) \
		__t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++), \
		__t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++), \
		__t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++), \
		__t=t(*((uint8*)__s)++)<<16, \
			*((uint32*)__d)++=__t|=t(*((uint8*)__s)++); \
	if(__z&1) *(uint16*)__d=t(*(uint8*)__s);}while(0)
/* 2x1x15bpp */
 #define _hcpy2(d,s,c,t) do{ \
	void *__d=d; const void *__s=s; /*uint32 *__dd=(uint32*)((r)+(uint8*)__d);*/ \
	int32 __z=c; \
	if(__z&1) *((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001; \
	if(__z&2) *((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001; \
	if(__z&4) *((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001; \
	if (__z&=-8L) do{ \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001, \
		*((uint32*)__d)++=t(*((uint8*)__s)++)*0x10001; \
	} while(__z+=-8L);}while(0)
/* 1x1x24bpp */
#define _tcpy(d,s,c,b,t) do{ \
	void *__d=d; const void *__s=s; int32 __z=c; \
	if(__z&1L) *((b*)__d)++=t(*((uint8*)__s)++); \
	if(__z&2L) *((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=t(*((uint8*)__s)++); \
	if(__z&4L) *((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=t(*((uint8*)__s)++); \
	if (__z&=-8L) do{ \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=t(*((uint8*)__s)++); \
	} while(__z+=-8L);}while(0)
/* 1x1x32bpp */
 #define _tcpy2(d,s,c,b,t) do{ \
	void *__d=d; const void *__s=s; /*b *__dd=(b*)((r)+(uint8*)d);*/ int32 __z=c; \
	if(__z&1L) *((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
	if(__z&2L) *((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
	if(__z&4L) *((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++), \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
	if (__z&=-8L) do{ \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
		*((b*)__d)++=*((b*)__d)++=t(*((uint8*)__s)++); \
	} while(__z+=-8L);}while(0)

#define _t(x)					t[x]

void BlitScreen(const uint8 *XBuf,
	int rowsize,
	const struct Rect *blitrect,
	const struct PixMap **dstblitmap)
{
	const PixMap	*m;
	const uint8	*s = XBuf;
	uint8		*d;
	int		b, sx, sy, w, h, dx, dy;
	unsigned	r, ssh;

	if (!dstblitmap || (m=*dstblitmap)==NULL
			|| (d=(uint8*)m->baseAddr)==NULL
			|| (dx=m->bounds.left)>0 /* negative window origin */
			|| (dy=m->bounds.top)>0)
		return;
	ssh = screenshift;
	sx = blitrect->left<<ssh, sy = blitrect->top;
	/* clip width/height */
	w = blitrect->right<<ssh, h = blitrect->bottom;
	if (w>m->bounds.right)
		w = m->bounds.right;
	if (h>m->bounds.bottom)
		h = m->bounds.bottom;
	if ((w=(w-sx)>>ssh)<=0 || (h-=sy)<=0)
		return;
	b = m->pixelSize;
	r = m->rowBytes&0x3FFF;
	s+= sy*rowsize+(sx>>ssh);
	d+= (sy-dy+0u)*r+((sx-dx+0u)*b>>3);
	if ((b-=8)<0)
		return;
	if (!b)
	{ /* 8bpp */
		if (ssh)
			do _bcpy2(d,s,w); while(d+=r,s+=rowsize,--h);
		else
			do _bcpy(d,s,w); while(d+=r,s+=rowsize,--h);
	} else if ((b-=8)<=0)
	{ /* 15bpp (2Bpp) */
		const uint32	*t = myctable15;

		if (ssh)
			do _hcpy2(d,s,w,_t); while(d+=r,s+=rowsize,--h);
		else
			do _hcpy(d,s,w,_t); while(d+=r,s+=rowsize,--h);
	} else
	{ /* assume 24bpp (4Bpp) */
		const uint32	*t = myctable32;

		if (ssh)
			do _tcpy2(d,s,w,uint32,_t); while(d+=r,s+=rowsize,--h);
		else
			do _tcpy(d,s,w,uint32,_t); while(d+=r,s+=rowsize,--h);
	}
}
